<template>
  <main class="HomeView">
    <div class="Calendar" ref="element">
      <MachineLane
        v-for="machine of workshop.machines"
        :key="machine.id"
        :machine="machine"
        :now="Now"
        :offset-now="offsetNow"
        :resolution="resolution"
      />
    </div>
    <Backlog :resolution="resolution" />
  </main>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue'
import { Icons } from '@/Icons'
import { backlogOrders, Now, workshop } from '@/states'
import Backlog from '@/views/partial/Backlog.vue'
import MachineLane from '@/views/partial/MachineLane.vue'

export default defineComponent({
  name: 'Home',
  components: { MachineLane, Backlog },

  setup() {
    const element = ref<HTMLDivElement>()
    const OFFSET_NOW = 600
    onMounted(() => {
      if (element.value) element.value.scrollLeft = OFFSET_NOW / 2
    })
    return {
      Icons,
      workshop,
      backlogOrders,
      // ration pixel per hour
      resolution: 120,
      offsetNow: OFFSET_NOW,
      Now,
      element,
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../style/variables' as v;
@use '../style/view';

.HomeView {
  @extend .View;

  padding: 0;

  .Backlog {
    flex: 1 1;
  }

  .Calendar {
    display: flex;
    flex: 0 0 auto;
    flex-direction: column;
    overflow-x: visible;
    overflow-y: hidden;
    width: 100vw;
    min-width: 100vw;
    max-width: 100vw;
    height: max-content;
  }
}
</style>
